/*
 * $Header: /cvsroot/opencryptoki/opencryptoki/usr/lib/pkcs11/api/msg.h,v 1.1.1.1 2005/01/18 16:09:00 kyoder Exp $
 */

//
/*
             Common Public License Version 0.5

             THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF
             THIS COMMON PUBLIC LICENSE ("AGREEMENT"). ANY USE,
             REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES
             RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.

             1. DEFINITIONS

             "Contribution" means: 
                   a) in the case of the initial Contributor, the
                   initial code and documentation distributed under
                   this Agreement, and 

                   b) in the case of each subsequent Contributor:
                   i) changes to the Program, and
                   ii) additions to the Program;

                   where such changes and/or additions to the Program
                   originate from and are distributed by that
                   particular Contributor. A Contribution 'originates'
                   from a Contributor if it was added to the Program
                   by such Contributor itself or anyone acting on such
                   Contributor's behalf. Contributions do not include
                   additions to the Program which: (i) are separate
                   modules of software distributed in conjunction with
                   the Program under their own license agreement, and
                   (ii) are not derivative works of the Program.


             "Contributor" means any person or entity that distributes
             the Program.

             "Licensed Patents " mean patent claims licensable by a
             Contributor which are necessarily infringed by the use or
             sale of its Contribution alone or when combined with the
             Program. 

             "Program" means the Contributions distributed in
             accordance with this Agreement.

             "Recipient" means anyone who receives the Program under
             this Agreement, including all Contributors.

             2. GRANT OF RIGHTS

                   a) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free copyright
                   license to reproduce, prepare derivative works of,
                   publicly display, publicly perform, distribute and
                   sublicense the Contribution of such Contributor, if
                   any, and such derivative works, in source code and
                   object code form.

                   b) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free patent
                   license under Licensed Patents to make, use, sell,
                   offer to sell, import and otherwise transfer the
                   Contribution of such Contributor, if any, in source
                   code and object code form. This patent license
                   shall apply to the combination of the Contribution
                   and the Program if, at the time the Contribution is
                   added by the Contributor, such addition of the
                   Contribution causes such combination to be covered
                   by the Licensed Patents. The patent license shall
                   not apply to any other combinations which include
                   the Contribution. No hardware per se is licensed
                   hereunder.

                   c) Recipient understands that although each
                   Contributor grants the licenses to its
                   Contributions set forth herein, no assurances are
                   provided by any Contributor that the Program does
                   not infringe the patent or other intellectual
                   property rights of any other entity. Each
                   Contributor disclaims any liability to Recipient
                   for claims brought by any other entity based on
                   infringement of intellectual property rights or
                   otherwise. As a condition to exercising the rights
                   and licenses granted hereunder, each Recipient
                   hereby assumes sole responsibility to secure any
                   other intellectual property rights needed, if any.

                   For example, if a third party patent license is
                   required to allow Recipient to distribute the
                   Program, it is Recipient's responsibility to
                   acquire that license before distributing the
                   Program.

                   d) Each Contributor represents that to its
                   knowledge it has sufficient copyright rights in its
                   Contribution, if any, to grant the copyright
                   license set forth in this Agreement.

             3. REQUIREMENTS

             A Contributor may choose to distribute the Program in
             object code form under its own license agreement, provided
             that:
                   a) it complies with the terms and conditions of
                   this Agreement; and

                   b) its license agreement:
                   i) effectively disclaims on behalf of all
                   Contributors all warranties and conditions, express
                   and implied, including warranties or conditions of
                   title and non-infringement, and implied warranties
                   or conditions of merchantability and fitness for a
                   particular purpose;

                   ii) effectively excludes on behalf of all
                   Contributors all liability for damages, including
                   direct, indirect, special, incidental and
                   consequential damages, such as lost profits;

                   iii) states that any provisions which differ from
                   this Agreement are offered by that Contributor
                   alone and not by any other party; and

                   iv) states that source code for the Program is
                   available from such Contributor, and informs
                   licensees how to obtain it in a reasonable manner
                   on or through a medium customarily used for
                   software exchange.

             When the Program is made available in source code form:
                   a) it must be made available under this Agreement;
                   and
                   b) a copy of this Agreement must be included with
                   each copy of the Program. 

             Contributors may not remove or alter any copyright notices
             contained within the Program.

             Each Contributor must identify itself as the originator of
             its Contribution, if any, in a manner that reasonably
             allows subsequent Recipients to identify the originator of
             the Contribution. 


             4. COMMERCIAL DISTRIBUTION

             Commercial distributors of software may accept certain
             responsibilities with respect to end users, business
             partners and the like. While this license is intended to
             facilitate the commercial use of the Program, the
             Contributor who includes the Program in a commercial
             product offering should do so in a manner which does not
             create potential liability for other Contributors.
             Therefore, if a Contributor includes the Program in a
             commercial product offering, such Contributor ("Commercial
             Contributor") hereby agrees to defend and indemnify every
             other Contributor ("Indemnified Contributor") against any
             losses, damages and costs (collectively "Losses") arising
             from claims, lawsuits and other legal actions brought by a
             third party against the Indemnified Contributor to the
             extent caused by the acts or omissions of such Commercial
             Contributor in connection with its distribution of the
             Program in a commercial product offering. The obligations
             in this section do not apply to any claims or Losses
             relating to any actual or alleged intellectual property
             infringement. In order to qualify, an Indemnified
             Contributor must: a) promptly notify the Commercial
             Contributor in writing of such claim, and b) allow the
             Commercial Contributor to control, and cooperate with the
             Commercial Contributor in, the defense and any related
             settlement negotiations. The Indemnified Contributor may
             participate in any such claim at its own expense.


             For example, a Contributor might include the Program in a
             commercial product offering, Product X. That Contributor
             is then a Commercial Contributor. If that Commercial
             Contributor then makes performance claims, or offers
             warranties related to Product X, those performance claims
             and warranties are such Commercial Contributor's
             responsibility alone. Under this section, the Commercial
             Contributor would have to defend claims against the other
             Contributors related to those performance claims and
             warranties, and if a court requires any other Contributor
             to pay any damages as a result, the Commercial Contributor
             must pay those damages.


             5. NO WARRANTY

             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE
             PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT
             WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR
             IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR
             CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR
             FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely
             responsible for determining the appropriateness of using
             and distributing the Program and assumes all risks
             associated with its exercise of rights under this
             Agreement, including but not limited to the risks and
             costs of program errors, compliance with applicable laws,
             damage to or loss of data, programs or equipment, and
             unavailability or interruption of operations. 

             6. DISCLAIMER OF LIABILITY
             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER
             RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY
             FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
             OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION
             LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF
             LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
             (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
             OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE
             OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE
             POSSIBILITY OF SUCH DAMAGES.

             7. GENERAL

             If any provision of this Agreement is invalid or
             unenforceable under applicable law, it shall not affect
             the validity or enforceability of the remainder of the
             terms of this Agreement, and without further action by the
             parties hereto, such provision shall be reformed to the
             minimum extent necessary to make such provision valid and
             enforceable.


             If Recipient institutes patent litigation against a
             Contributor with respect to a patent applicable to
             software (including a cross-claim or counterclaim in a
             lawsuit), then any patent licenses granted by that
             Contributor to such Recipient under this Agreement shall
             terminate as of the date such litigation is filed. In
             addition, If Recipient institutes patent litigation
             against any entity (including a cross-claim or
             counterclaim in a lawsuit) alleging that the Program
             itself (excluding combinations of the Program with other
             software or hardware) infringes such Recipient's
             patent(s), then such Recipient's rights granted under
             Section 2(b) shall terminate as of the date such
             litigation is filed.

             All Recipient's rights under this Agreement shall
             terminate if it fails to comply with any of the material
             terms or conditions of this Agreement and does not cure
             such failure in a reasonable period of time after becoming
             aware of such noncompliance. If all Recipient's rights
             under this Agreement terminate, Recipient agrees to cease
             use and distribution of the Program as soon as reasonably
             practicable. However, Recipient's obligations under this
             Agreement and any licenses granted by Recipient relating
             to the Program shall continue and survive. 

             Everyone is permitted to copy and distribute copies of
             this Agreement, but in order to avoid inconsistency the
             Agreement is copyrighted and may only be modified in the
             following manner. The Agreement Steward reserves the right
             to publish new versions (including revisions) of this
             Agreement from time to time. No one other than the
             Agreement Steward has the right to modify this Agreement.

             IBM is the initial Agreement Steward. IBM may assign the
             responsibility to serve as the Agreement Steward to a
             suitable separate entity. Each new version of the
             Agreement will be given a distinguishing version number.
             The Program (including Contributions) may always be
             distributed subject to the version of the Agreement under
             which it was received. In addition, after a new version of
             the Agreement is published, Contributor may elect to
             distribute the Program (including its Contributions) under
             the new version. Except as expressly stated in Sections
             2(a) and 2(b) above, Recipient receives no rights or
             licenses to the intellectual property of any Contributor
             under this Agreement, whether expressly, by implication,
             estoppel or otherwise. All rights in the Program not
             expressly granted under this Agreement are reserved.


             This Agreement is governed by the laws of the State of New
             York and the intellectual property laws of the United
             States of America. No party to this Agreement will bring a
             legal action under this Agreement more than one year after
             the cause of action arose. Each party waives its rights to
             a jury trial in any resulting litigation. 



*/

/* (C) COPYRIGHT International Business Machines Corp. 2001          */

// File: msg.h
// Error Messages used by st_err_log

struct messages {
	char *   msg;
};

struct messages err_msg[]={
		{"%s:%d Malloc Failed"},
		{"%s:%d Not Enough Memory in Context"},
		{"%s:%d Slot Invalid"},
		{"%s:%d General Error"},
		{"%s:%d %s Function Failed"},
		//#5
		{"%s:%d %s Bad Arguments"},
		{"%s:%d No Event"},
		{"%s:%d Attribute Read Only"},
		{"%s:%d Attribute Type Invalid"},
		{"%s:%d Attribute Value Invalid"},
		//#10
		{"%s:%d Data Invalid"},
		{"%s:%d Data Length out of Range"},
		{"%s:%d Device Error"},
		{"%s:%d Device Removed"},
		{"%s:%d Encrypted Data Invalid"},
		//15
		{"%s:%d Encrypted Data Length out of Range"},
		{"%s:%d Function Cancelled"},
		{"%s:%d Function Not Parallel"},
		{"%s:%d Key Handle Invalid"},
		{"%s:%d Key Size out of Range"},
		//20
		{"%s:%d Key Type Inconsistent"},
		{"%s:%d Key Not Needed"},
		{"%s:%d Key Changed"},
		{"%s:%d Key Needed"},
		{"%s:%d Key Indigestible"},
		//25
		{"%s:%d Key Function Not Permitted"},
		{"%s:%d Key Not Wrappable"},
		{"%s:%d Key Unextractable"},
		{"%s:%d Mechanism Invalid"},
		{"%s:%d Mechanism Param Invalid"},
		//30
		{"%s:%d Object Handle Invalid"},
		{"%s:%d Operation Active"},
		{"%s:%d Operation Not Initialized"},
		{"%s:%d Pin Incorrect"},
		{"%s:%d Pin Invalid"},
		//35
		{"%s:%d Pin Length out of Range"},
		{"%s:%d Pin Expired"},
		{"%s:%d Pin Locked"},
		{"%s:%d Session Closed"},
		{"%s:%d Session Count"},
		//40
		{"%s:%d Session Handle Invalid"},
		{"%s:%d Parallel Session Not Supported"},
		{"%s:%d Session Read Only"},
		{"%s:%d Session Exists"},
		{"%s:%d Session Read only Exists"},
		//45
		{"%s:%d Session Read Write Exists"},
		{"%s:%d Signature Length out of Range"},
		{"%s:%d Signature Invalid"},
		{"%s:%d Template Incomplete"},
		{"%s:%d Template Inconsistent"},
		//50
		{"%s:%d Token Not Present"},
		{"%s:%d Token Not Recognized"},
		{"%s:%d Token Write Protected"},
		{"%s:%d Unwrapping Key Handle Invalid"},
		{"%s:%d Unwrapping Key Size Range Invalid"},
		//55
		{"%s:%d Unwrapping Key Type Inconsistent"},
		{"%s:%d User Already Logged In"},
		{"%s:%d User Not Logged In"},
		{"%s:%d User PIN Not Initialized"},
		{"%s:%d User Type Invalid"},
		//60
		{"%s:%d Another User Already Logged In"},
		{"%s:%d Too Many User Types"},
		{"%s:%d Wrapped Key Invalid"},
		{"%s:%d Wrapped Key Length Out of Range"},
		{"%s:%d Wrapping Key Size out of Range"},
		//65
		{"%s:%d Wrapping Key Type Inconsistent"},
		{"%s:%d Random Seed Not Supported"},
		{"%s:%d Random Number Invalid"},
		{"%s:%d Buffer Too Small"},
		{"%s:%d Saved State Invalid"},
		//70
		{"%s:%d Information Sensitive"},
		{"%s:%d State Unsaveable"},
		{"%s:%d API not initialized"},
		{"%s:%d API already Initialized"},
		{"%s:%d Mutex Bad"},
		//75
		{"%s:%d Mutex Lock Invalid"},
		{"%s:%d Encode Integer Failed"},
		{"%s:%d Encode Octet String Failed"},
		{"%s:%d Encode Sequence Failed"},
		{"%s:%d Decode Integer Failed"},
		//80
		{"%s:%d Decode Octet String Failed"},
		{"%s:%d Decode Sequence Failed"},
		{"%s:%d Encode Private Key Failed"},
		{"%s:%d Decode Private Key Failed"},
		{"%s:%d Build Attribute Failed"},
		//85
		{"%s:%d Function Not Permitted"},
		{"%s:%d Key Not Exportable"},
		{"%s:%d Encode Private Key failed"},
		{"%s:%d Decode Private Key failed"},
		{"%s:%d Object Mgr Create Skeleton failed"},
		//90
		{"%s:%d Object Mgr Create Final failed"},
		{"%s:%d Key Generation failed"},
		{"%s:%d DES Wrap Get Data Failed"},
		{"%s:%d DES3 Wrap Get Data Failed"},
		{"%s:%d RSA Wrap Get Data Failed"},
		//95
		{"%s:%d DSA Wrap Get Data Failed"},
		{"%s:%d Generic Secret Wrap Get Data Failed"},
		{"%s:%d DES Wrap Format Failed"},
		{"%s:%d Encryption Mgr Init Failed"},
		{"%s:%d Encryption Mgr Encrypt Failed"},
		//100
		{"%s:%d Decryption Mgr Decrypt Failed"},
		{"%s:%d Flatten Object Failed"},
		{"%s:%d Key Mgr Get Priv Key Type Failed"},
		{"%s:%d Decrypt Private Key Info Failed"},
		{"%s:%d Save Token Failed"},
		//105
		{"%s:%d Triple DES CBC Encrypt Failed"},
		{"%s:%d Triple DES CBC Decrypt Failed"},
		{"%s:%d Restore Private Token Failed"},
		{"%s:%d Restore Object Failed"},
		{"%s:%d Data Length Out of Range"},
		//110
		{"%s:%d Object Manager Find in Map Failed"},
		{"%s:%d Token Specific RNG Failed"},
		{"%s:%d Encrypted Data Length Out of Range"},
		{"%s:%d DES CBC Encrypt Failed"},
		{"%s:%d DES CBC Decrypt Failed"},
		//115
		{"%s:%d DES ECB Encrypt Failed"},
		{"%s:%d DES ECB Decrypt Failed"},
		{"%s:%d Token Specific DES ECB Failed"},
		{"%s:%d Token Specific DES CBC Failed"},
		{"%s:%d Token Specific 3DES CBC Failed"},
		//120
		{"%s:%d Token Specific 3DES ECB Failed"},
		{"%s:%d DSA Verify Failed"},
		{"%s:%d DSA Sign Failed"},
		{"%s:%d Digest Init Failed"},
		{"%s:%d Digest Failed"},
		//125
		{"%s:%d Digest Update Failed"},
		{"%s:%d Digest Final Failed"},
		{"%s:%d Sign Init Failed"},
		{"%s:%d Sign Update Failed"},
		{"%s:%d Sign Final Failed"},
		//130
		{"%s:%d Random Number Generate Failed"},
		{"%s:%d RSA Format Block Failed"},
		{"%s:%d RSA Encrypt Failed"},
		{"%s:%d RSA Decrypt Failed"},
		{"%s:%d Token Specific RSA Encrypt Failed"},
		//135
		{"%s:%d Token Specific RSA Decrypt Failed"},
		{"%s:%d SSL SHA Failed"},
		{"%s:%d SSL3 MD5 Failed"},
		{"%s:%d SSL3 Process MAC Keys Failed"},
		{"%s:%d SSL3 Process Write Keys Failed"},
		//140
		{"%s:%d Validate Attribute Failed"},
		{"%s:%d SSL3 Process Write Keys Failed"},
		{"%s:%d %s Function Not Supported"},
		{"%s:%d Token Already Initialized"},
		{"%s:%d Cannot Attach to Shared Memory"},
		//145
		{"%s:%d Token Specific Init Failed"},
		{"%s:%d Mutex Lock Failed"},
		{"%s:%d Mutex Unlock Failed"},
		{"%s:%d Hash Computation Failed"},
		{"%s:%d Save Master Key Failed"},
		//150
		{"%s:%d Process Lock Failed"},
		{"%s:%d Process Unlock Failed"},
		{"%s:%d Session Mgr New Failed"},
		{"%s:%d Close all Sessions Failed"},
		{"%s:%d Session Mgr Get Op State Failed"},
		//155
		{"%s:%d Load Master Key Failed"},
		{"%s:%d Object Create Failed"},
		{"%s:%d Object Mgr Add to Map Failed"},
		{"%s:%d Object Copy Failed"},
		{"%s:%d Object Get Attribute Values Failed"},
		//160
		{"%s:%d Object Restore Data Failed"},
		{"%s:%d Object Set Attribute Values Failed"},
		{"%s:%d Object Mgr Search for Object Failed"},
		{"%s:%d Copy Template Failed"},
		{"%s:%d Add Attribute Failed"},
		//165
		{"%s:%d Check Required Attributes Failed"},
		{"%s:%d Unflatten Template Failed"},
		{"%s:%d Verify Init Failed"},
		{"%s:%d Verify Failed"},
		{"%s:%d Verify Update Failed"},
		//170
		{"%s:%d Verify Final Failed"},
		{"%s:%d Sign Failed"},
		{"%s:%d Set Default Attributes Failed"},
		{"%s:%d Unwrap Key Failed"},
		{"%s:%d Session Mgr New Failed"},
		//175
		{"%s:%d Merge Attributes Failed"},
		{"%s:%d Encryption Mgr Encrypt Update Failed"},
		{"%s:%d Encryption Mgr Encrypt Final Failed"},
		{"%s:%d Update Attribute Failed"},
		{"%s:%d Decryption Mgr Init Failed"},
		//180
		{"%s:%d Decryption Mgr Update Failed"},
		{"%s:%d Decryption Mgr Final Failed"},
		{"%s:%d Object Mgr Destroy Failed"},
		{"%s:%d Attribute Undefined"},
		{"%s:%d Object Mgr Get Size Failed"},
		//185
		{"%s:%d Object Manager Find Init Failed"},
		{"%s:%d Sign Recover Failed"},
		{"%s:%d Verify Recover Failed"},
		{"%s:%d Wrap Key Failed"},
		{"%s:%d Unwrap Key Failed"},
		//190
		{"%s:%d Derive Key Failed"},
		{"%s:%d AES Wrap Get Data Failed"},
		{"%s:%d AES Wrap Format Failed"},
		{"%s:%d Domain Parameter Invalid"},
		{"%s:%d File \"%s\" could not be opened, errno=%d"}
               };
