/*
             Common Public License Version 0.5

             THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF
             THIS COMMON PUBLIC LICENSE ("AGREEMENT"). ANY USE,
             REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES
             RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.

             1. DEFINITIONS

             "Contribution" means: 
                   a) in the case of the initial Contributor, the
                   initial code and documentation distributed under
                   this Agreement, and 

                   b) in the case of each subsequent Contributor:
                   i) changes to the Program, and
                   ii) additions to the Program;

                   where such changes and/or additions to the Program
                   originate from and are distributed by that
                   particular Contributor. A Contribution 'originates'
                   from a Contributor if it was added to the Program
                   by such Contributor itself or anyone acting on such
                   Contributor's behalf. Contributions do not include
                   additions to the Program which: (i) are separate
                   modules of software distributed in conjunction with
                   the Program under their own license agreement, and
                   (ii) are not derivative works of the Program.


             "Contributor" means any person or entity that distributes
             the Program.

             "Licensed Patents " mean patent claims licensable by a
             Contributor which are necessarily infringed by the use or
             sale of its Contribution alone or when combined with the
             Program. 

             "Program" means the Contributions distributed in
             accordance with this Agreement.

             "Recipient" means anyone who receives the Program under
             this Agreement, including all Contributors.

             2. GRANT OF RIGHTS

                   a) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free copyright
                   license to reproduce, prepare derivative works of,
                   publicly display, publicly perform, distribute and
                   sublicense the Contribution of such Contributor, if
                   any, and such derivative works, in source code and
                   object code form.

                   b) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free patent
                   license under Licensed Patents to make, use, sell,
                   offer to sell, import and otherwise transfer the
                   Contribution of such Contributor, if any, in source
                   code and object code form. This patent license
                   shall apply to the combination of the Contribution
                   and the Program if, at the time the Contribution is
                   added by the Contributor, such addition of the
                   Contribution causes such combination to be covered
                   by the Licensed Patents. The patent license shall
                   not apply to any other combinations which include
                   the Contribution. No hardware per se is licensed
                   hereunder.

                   c) Recipient understands that although each
                   Contributor grants the licenses to its
                   Contributions set forth herein, no assurances are
                   provided by any Contributor that the Program does
                   not infringe the patent or other intellectual
                   property rights of any other entity. Each
                   Contributor disclaims any liability to Recipient
                   for claims brought by any other entity based on
                   infringement of intellectual property rights or
                   otherwise. As a condition to exercising the rights
                   and licenses granted hereunder, each Recipient
                   hereby assumes sole responsibility to secure any
                   other intellectual property rights needed, if any.

                   For example, if a third party patent license is
                   required to allow Recipient to distribute the
                   Program, it is Recipient's responsibility to
                   acquire that license before distributing the
                   Program.

                   d) Each Contributor represents that to its
                   knowledge it has sufficient copyright rights in its
                   Contribution, if any, to grant the copyright
                   license set forth in this Agreement.

             3. REQUIREMENTS

             A Contributor may choose to distribute the Program in
             object code form under its own license agreement, provided
             that:
                   a) it complies with the terms and conditions of
                   this Agreement; and

                   b) its license agreement:
                   i) effectively disclaims on behalf of all
                   Contributors all warranties and conditions, express
                   and implied, including warranties or conditions of
                   title and non-infringement, and implied warranties
                   or conditions of merchantability and fitness for a
                   particular purpose;

                   ii) effectively excludes on behalf of all
                   Contributors all liability for damages, including
                   direct, indirect, special, incidental and
                   consequential damages, such as lost profits;

                   iii) states that any provisions which differ from
                   this Agreement are offered by that Contributor
                   alone and not by any other party; and

                   iv) states that source code for the Program is
                   available from such Contributor, and informs
                   licensees how to obtain it in a reasonable manner
                   on or through a medium customarily used for
                   software exchange.

             When the Program is made available in source code form:
                   a) it must be made available under this Agreement;
                   and
                   b) a copy of this Agreement must be included with
                   each copy of the Program. 

             Contributors may not remove or alter any copyright notices
             contained within the Program.

             Each Contributor must identify itself as the originator of
             its Contribution, if any, in a manner that reasonably
             allows subsequent Recipients to identify the originator of
             the Contribution. 


             4. COMMERCIAL DISTRIBUTION

             Commercial distributors of software may accept certain
             responsibilities with respect to end users, business
             partners and the like. While this license is intended to
             facilitate the commercial use of the Program, the
             Contributor who includes the Program in a commercial
             product offering should do so in a manner which does not
             create potential liability for other Contributors.
             Therefore, if a Contributor includes the Program in a
             commercial product offering, such Contributor ("Commercial
             Contributor") hereby agrees to defend and indemnify every
             other Contributor ("Indemnified Contributor") against any
             losses, damages and costs (collectively "Losses") arising
             from claims, lawsuits and other legal actions brought by a
             third party against the Indemnified Contributor to the
             extent caused by the acts or omissions of such Commercial
             Contributor in connection with its distribution of the
             Program in a commercial product offering. The obligations
             in this section do not apply to any claims or Losses
             relating to any actual or alleged intellectual property
             infringement. In order to qualify, an Indemnified
             Contributor must: a) promptly notify the Commercial
             Contributor in writing of such claim, and b) allow the
             Commercial Contributor to control, and cooperate with the
             Commercial Contributor in, the defense and any related
             settlement negotiations. The Indemnified Contributor may
             participate in any such claim at its own expense.


             For example, a Contributor might include the Program in a
             commercial product offering, Product X. That Contributor
             is then a Commercial Contributor. If that Commercial
             Contributor then makes performance claims, or offers
             warranties related to Product X, those performance claims
             and warranties are such Commercial Contributor's
             responsibility alone. Under this section, the Commercial
             Contributor would have to defend claims against the other
             Contributors related to those performance claims and
             warranties, and if a court requires any other Contributor
             to pay any damages as a result, the Commercial Contributor
             must pay those damages.


             5. NO WARRANTY

             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE
             PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT
             WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR
             IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR
             CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR
             FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely
             responsible for determining the appropriateness of using
             and distributing the Program and assumes all risks
             associated with its exercise of rights under this
             Agreement, including but not limited to the risks and
             costs of program errors, compliance with applicable laws,
             damage to or loss of data, programs or equipment, and
             unavailability or interruption of operations. 

             6. DISCLAIMER OF LIABILITY
             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER
             RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY
             FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
             OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION
             LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF
             LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
             (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
             OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE
             OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE
             POSSIBILITY OF SUCH DAMAGES.

             7. GENERAL

             If any provision of this Agreement is invalid or
             unenforceable under applicable law, it shall not affect
             the validity or enforceability of the remainder of the
             terms of this Agreement, and without further action by the
             parties hereto, such provision shall be reformed to the
             minimum extent necessary to make such provision valid and
             enforceable.


             If Recipient institutes patent litigation against a
             Contributor with respect to a patent applicable to
             software (including a cross-claim or counterclaim in a
             lawsuit), then any patent licenses granted by that
             Contributor to such Recipient under this Agreement shall
             terminate as of the date such litigation is filed. In
             addition, If Recipient institutes patent litigation
             against any entity (including a cross-claim or
             counterclaim in a lawsuit) alleging that the Program
             itself (excluding combinations of the Program with other
             software or hardware) infringes such Recipient's
             patent(s), then such Recipient's rights granted under
             Section 2(b) shall terminate as of the date such
             litigation is filed.

             All Recipient's rights under this Agreement shall
             terminate if it fails to comply with any of the material
             terms or conditions of this Agreement and does not cure
             such failure in a reasonable period of time after becoming
             aware of such noncompliance. If all Recipient's rights
             under this Agreement terminate, Recipient agrees to cease
             use and distribution of the Program as soon as reasonably
             practicable. However, Recipient's obligations under this
             Agreement and any licenses granted by Recipient relating
             to the Program shall continue and survive. 

             Everyone is permitted to copy and distribute copies of
             this Agreement, but in order to avoid inconsistency the
             Agreement is copyrighted and may only be modified in the
             following manner. The Agreement Steward reserves the right
             to publish new versions (including revisions) of this
             Agreement from time to time. No one other than the
             Agreement Steward has the right to modify this Agreement.

             IBM is the initial Agreement Steward. IBM may assign the
             responsibility to serve as the Agreement Steward to a
             suitable separate entity. Each new version of the
             Agreement will be given a distinguishing version number.
             The Program (including Contributions) may always be
             distributed subject to the version of the Agreement under
             which it was received. In addition, after a new version of
             the Agreement is published, Contributor may elect to
             distribute the Program (including its Contributions) under
             the new version. Except as expressly stated in Sections
             2(a) and 2(b) above, Recipient receives no rights or
             licenses to the intellectual property of any Contributor
             under this Agreement, whether expressly, by implication,
             estoppel or otherwise. All rights in the Program not
             expressly granted under this Agreement are reserved.


             This Agreement is governed by the laws of the State of New
             York and the intellectual property laws of the United
             States of America. No party to this Agreement will bring a
             legal action under this Agreement more than one year after
             the cause of action arose. Each party waives its rights to
             a jury trial in any resulting litigation. 



*/

/* (C) COPYRIGHT International Business Machines Corp. 2001          */



#include "pthread.h"

#include "pkcsslotd.h"
#include <string.h>
#include <strings.h>




#define   ODM_DIRECTORY  CONFIG_PATH





/*****************************
 *    Function Prototypes    *
 *****************************/
 
static BOOL            BlankPadNoNull ( char *Dest, char *Src, u_int32 SrcLen );

#ifdef PKCS64
static void            PrintSlotInfo ( Slot_Info_t_64 *P );
#else
static void            PrintSlotInfo ( Slot_Info_t *P );
#endif





BOOL BooleanVal ( char *ptr, int length, BOOL *result ) {

  int     i;
  char    *p = ptr;

  /* Takes a text-based way of entering Yes/No and converts it to 1 or 0 */
  if ( ptr == NULL ) return FALSE;


  /* skip over leading whitespace */

  i = 0;

  while ( (i < length) && (isspace(ptr[i])) ) {
    i++;
  }

  if ( i >= length ) {
    *result = FALSE;
    return TRUE;
  }

  /* p points to the 1st non-space character */
  p = &(ptr[i]);


  /* Does p start with Y|T|1 (yes, True, 1)? */
  if ( p[0] == 'y' || 
       p[0] == 'Y' ||
       p[0] == 'T' ||
       p[0] == 't' ) {
    *result = TRUE;
    return TRUE;
  }

  /* What about N|F|0 (zero)? */
  if ( p[0] == 'n' || 
       p[0] == 'N' || 
       p[0] == '0' ||
       p[0] == 'F' ||
       p[0] == 'f' ) {
    *result = FALSE;
    return TRUE;
  }

  /* 0 is checked for above.  Any other number is TRUE */
  if ( isdigit( p[0] ) ) {
    *result = TRUE;
    return TRUE;
  }

  /* We've got unrecognized data */

  return FALSE;

}








#ifdef PKCS64
void PrintSlotInfo ( Slot_Info_t_64 *P ) {
#else
void PrintSlotInfo ( Slot_Info_t *P ) {
#endif

#ifdef PKCS64
  CK_SLOT_INFO_64       *ck = NULL;
#else
  CK_SLOT_INFO          *ck = NULL;
#endif

  ck = &(P->pk_slot);

  if (! P->present) return;

  DbgLog(DL3, "slot_number:             %d",      P->slot_number);
  DbgLog(DL3, "present    :             %d",      P->present);
  DbgLog(DL3, "pk_slot    :");
  DbgLog(DL3, "     slotDescription:    '%.64s'", ck->slotDescription);
  DbgLog(DL3, "     manufacturerID :    '%.32s'", ck->manufacturerID);
  DbgLog(DL3, "     flags          :    %#x",     ck->flags);
  DbgLog(DL3, "     hardwareVersion:    %d.%d",   ck->hardwareVersion.major, ck->hardwareVersion.minor);
  DbgLog(DL3, "     firmwareVersion:    %d.%d",   ck->firmwareVersion.major, ck->firmwareVersion.minor);
  DbgLog(DL3, "dll_location:            '%s'",    P->dll_location);
  DbgLog(DL3, "slot_init_fcn:           '%s'",    P->slot_init_fcn);
  DbgLog(DL3, "correlator:              '%s'",    P->correlator);
  DbgLog(DL3, "global_sessions:         %#X",     P->global_sessions);
  DbgLog(DL3, "************************************************");
  return;

}




static BOOL BlankPadNoNull ( char *Dest, char *Src, u_int32 Len ) {

  char *s = NULL;

  /* Allocate Len bytes */
  if ( (s = (char *) malloc(Len)) == NULL ) {
    return FALSE;
  }

  /* Fill with blanks */
  memset(s, ' ', Len);

  /* Copy the string, but not the trailing NULL */
  memcpy(s, Src, ( ( strlen(Src) < Len ) ? strlen(Src) : Len ) );

  /* Copy Len bytes into Dest */
  memcpy(Dest, s, Len);

  /* Free storage */
  free(s);

  return TRUE;

}



// Need to eliminate need for ODM here...  

BOOL ReadSlotInfoDB ( void ) {

  unsigned char          Index     = 0;
  char                   StartDir[PATH_MAX + 1];

  enum element_type { Present = 1, SlotNumber, SlotDescription, ManufacturerID, TokenPresent, RemovableToken, HardwareSlot, HwVersionMajor, HwVersionMinor, FwVersionMajor, FwVersionMinor, Correlator, DLLLocation, SlotInitFcn };
  enum element_type element_num;

  char slot_entry[PATH_MAX], *slot_element;
  char separator[] = "|\n";
  //char separator[] = "|";
    BOOL                   Res      = FALSE;
#ifdef PKCS64
    CK_SLOT_INFO_64       *pSlot    = NULL;
#else
    CK_SLOT_INFO          *pSlot    = NULL;
#endif

#ifdef PKCS64
    Slot_Info_t_64	sinfo_struct;
#else
    Slot_Info_t		sinfo_struct;
#endif

  FILE *fp;


  sprintf(StartDir,"%s/%s", ODM_DIRECTORY, "pk_config_data");
  
  fp=fopen(StartDir, "r");
  if (fp == NULL) {
    fprintf(stderr, "\nCannot open file %s\n", StartDir);
    fprintf(stderr, "Please run %s/pkcs11_startup\n", SBIN_PATH);
    return FALSE;
  }


  /* first checking if the end of file hasn't been reached */
  // For some reason (strange)  on linux the FP gets nulled when the end of the file
  // is reached....SO, we just check for a valid FP first..
  while( fp && !feof(fp) ) {

    if( Index >= NUMBER_SLOTS_MANAGED )  // making sure all slots aren't filled in the sinfo array
      break;

#ifdef ALLOCATE
    slot_entry = (char *)malloc(sizeof(char)*(PATH_MAX));
#else
    bzero(slot_entry,PATH_MAX);
#endif

    fgets(slot_entry, PATH_MAX, fp);
    while( ( (slot_entry[0] == '#') ||
	     (slot_entry[0] == '\n') || 
	     (slot_entry[0] == (char)NULL) ) 
	   && (!feof(fp)) ) {
      // skipping all blank lines, and lines beginning with a #, at all times
      // AM I FORGETTING ANY OTHER CONDITIONS FOR BLANK LINES ??
      // SAB XXX Any one of these causes an abort
      fgets(slot_entry, PATH_MAX, fp);
    }


    // Check for null string...
    if ( slot_entry[0] == '\0')
	    break;
  //  if( feof(fp) )
  //    break;

    bzero(&sinfo_struct,sizeof(sinfo_struct));  // for good measure zero it out before use each time

    sinfo_struct.global_sessions = 0;	// initializing to zero
    element_num = Present;


    /* Present */

    slot_element = strtok(slot_entry, separator);
    if ( ! BooleanVal( slot_element, strlen(slot_element), &Res ) )	// BooleanVal(), correct value for 2nd parameter ??
      continue;

    if (Res)
      sinfo_struct.present = (CK_BOOL) Res;
    else
      break;	// skipping this entry if it's not "Present" ??

    element_num++;

    while( (slot_element = strtok(NULL, separator)) != NULL ) {	// continually parsing line, extracting the tokens separated by |
								// in variable string, slot_entry, and putting them in their
								// appropriate fields in the Slot_Info_t(_64) struct, sinfo_struct
    pSlot = &(sinfo_struct.pk_slot);




    switch(element_num) {
    /* Switch Statement to deal with each element of the slot, placing the elements in appropriate member of sinfo_struct */


    /* SlotNumber */

    case SlotNumber:
#if 0
#ifdef PKCS64
      sinfo_struct.slot_number = (CK_SLOT_ID_64) atoi(slot_element);
#else
      sinfo_struct.slot_number = (CK_SLOT_ID) atoi(slot_element);
#endif
#else
      sinfo_struct.slot_number = Index; // slot_element in config file is deprecated
#endif
      element_num++;
      break;


    /* SlotDescription */

    case SlotDescription:
      strncpy( (char *)(pSlot->slotDescription), slot_element, 
	( (strlen(slot_element) > sizeof(pSlot->slotDescription)) 
	  ? sizeof(pSlot->slotDescription) 
	  : (strlen(slot_element) ) ) );

      /* Set the last character in string to NULL since strncpy may mor may not copy the trailing NULL */
      pSlot->slotDescription[sizeof(pSlot->slotDescription) - 1] = (CK_CHAR)NULL;

      element_num++;
      break;


    /* ManufacturerID */

    case ManufacturerID:
      strncpy( (char *)(pSlot->manufacturerID), slot_element, 
	( (strlen(slot_element) > sizeof(pSlot->manufacturerID)) 
	  ? (sizeof(pSlot->manufacturerID)) 
	  : (strlen(slot_element) ) ) );

      /* Set the last character in string to NULL since strncpy may mor may not copy the trailing NULL */
      pSlot->manufacturerID[sizeof(pSlot->manufacturerID) - 1] = (CK_CHAR)NULL;

      element_num++;
      break;


    /* TokenPresent */

    case TokenPresent:
      pSlot->flags = 0x0; //NULL;	// initially setting to NULL
      Res = FALSE;		// resetting Res to FALSE before determining token type using BooleanVal() function
      if( BooleanVal(slot_element, strlen(slot_element), &Res) )
        if(Res == TRUE)
          pSlot->flags |= (CKF_TOKEN_PRESENT);
#if 0
         // SAB XXX  Since tokens can be removable, it is concievable that an
         // entry exists but the token is not present.... So the else clause is
         // not needed  Also all over the code you are changing the present
         // flag... probably not what you intended

      else
        sinfo_struct.present = (CK_BOOL) FALSE;
#endif



        /* fprintf(stderr, "\nUnrecognized data\n");  // not exactly sure about this. */
      element_num++;
      break;



    /* RemovableToken */

    case RemovableToken:
      if( BooleanVal(slot_element, strlen(slot_element), &Res) )
        if(Res == TRUE)
          pSlot->flags |= (CKF_REMOVABLE_DEVICE);
#if 0
         // SAB XXX  Since tokens can be removable, it is concievable that an
         // entry exists but the token is not present.... So the else clause is
         // not needed
      else
        sinfo_struct.present = (CK_BOOL) FALSE;
        /* fprintf(stderr, "\nUnrecognized data\n");  // not exactly sure about this. */
#endif
      element_num++;
      break;



    /* HardwareSlot */

    case HardwareSlot:
      if( BooleanVal(slot_element, strlen(slot_element), &Res) )
        if(Res == TRUE)
          pSlot->flags |= (CKF_HW_SLOT);
#if 0
      else
         // SAB XXX  Since tokens can be removable, it is concievable that an
         // entry exists but the token is not present.... So the else clause is
         // not needed
        sinfo_struct.present = (CK_BOOL) FALSE;
#endif
        /* fprintf(stderr, "\nUnrecognized data\n");  // not exactly sure about this. */
      if(pSlot->flags == 0x0  /*NULL*/ )		// making sure after all possible types have flags have been checked for
        fprintf(stderr, "\nUnrecognized token flag\n");	// the token has been labeled as one of them
      element_num++;
      break;



    /* HardwareVersion major and minor */

    case HwVersionMajor:
      pSlot->hardwareVersion.major = (CK_BYTE) atoi(slot_element);
      element_num++;
      break;
    case HwVersionMinor:
      pSlot->hardwareVersion.minor = (CK_BYTE) atoi(slot_element);
      element_num++;
      break;



    /*FirmwareVersion major and minor */

    case FwVersionMajor:
      pSlot->firmwareVersion.major = (CK_BYTE) atoi(slot_element);
      element_num++;
      break;
    case FwVersionMinor:
      pSlot->firmwareVersion.minor = (CK_BYTE) atoi(slot_element);
      element_num++;
      break;



    /* Correlator */

    case Correlator:
      // SAB XXX FIXME... be able to handle NULL correlator
      // for tokens which don't need this...  XXX
      if(slot_element[0] ==  0x0 /*NULL */ ) {
        sinfo_struct.correlator[0] = '\0';
      }
      else {
        strncpy( (sinfo_struct.correlator), slot_element, 
	  ( (strlen(slot_element) > sizeof(sinfo_struct.correlator)) 
	    ? (sizeof(sinfo_struct.correlator)) 
	    : (strlen(slot_element)) ) );
      
      /* Set the last character in string to NULL since strncpy may mor may not copy the trailing NULL */
      sinfo_struct.correlator[sizeof(sinfo_struct.correlator) - 1] = (char) NULL;
      }

      element_num++;
      break;



    /* DLLLocation */

    case DLLLocation:
      if(slot_element[0] == 0x0 /*NULL */) {	//finish later...
        sinfo_struct.dll_location[0] = (char)NULL;
      }
      else {
        strncpy( (sinfo_struct.dll_location), slot_element, 
          ( (strlen(slot_element) > sizeof(sinfo_struct.dll_location)) 
            ? (sizeof(sinfo_struct.dll_location)) 
		  : (strlen(slot_element)) ) );	// took away an ")"

      /* Set the last character in string to NULL since strncpy may mor may not copy the trailing NULL */
      sinfo_struct.dll_location[sizeof(sinfo_struct.dll_location) - 1] = (char) NULL;

#if 0      
      {
        /* check for file existance */
        struct stat statbuf;
        int Err;

        if ( stat( sinfo_struct.dll_location, &statbuf ) < 0 ) {
	  /* File not found, or other error */
	    Err = errno;

	  if ( Err == ENOENT ) {
            fprintf(stderr, "\nReading Slot Info: %s: file not found (%s).  Skipping slot entry.", sinfo_struct.dll_location, SysError(Err) );
	    /* WarnLog ( "***** ReadSlotInfoDB: %s: file not found (%s).  Skipping DB entry.", sinfo[Index].dll_location, SysError(Err) ); */
	  }
          else {
            fprintf(stderr, "\nReading Slot Info: looking at %s, stat64() returned %s (%d; %#x)", sinfo_struct.dll_location, SysError(Err), Err, Err);
	    /* DbgLog (DL0, "***** ReadSlotInfoDB: looking at %s, stat64() returned %s (%d; %#x)", sinfo[Index].dll_location, SysError(Err), Err, Err); */
	  }
	  memset( pSlot, '\0', sizeof(*pSlot) );
	  sinfo_struct.present = (CK_BOOL) FALSE;
	  continue;
        }

      } /* end DLLLocation unconditional block */
#endif
      }

      element_num++;
      break;



    /* SlotInitFcn */

    case SlotInitFcn:
      if(slot_element[0] == 0x0 /*NULL */) {     // finish later...
	sinfo_struct.slot_init_fcn[0] = (char)NULL;
    }
    else {
      // SAB  if there is not an initfcn then this entry is not used

      strncpy( (sinfo_struct.slot_init_fcn), 
	        slot_element, 
	     ( (strlen(slot_element) > sizeof(sinfo_struct.slot_init_fcn)) 
          ? (sizeof(sinfo_struct.slot_init_fcn)) 
	  : strlen(slot_element)) );

      /* Set the last character in string to NULL since strncpy may mor may not copy the trailing NULL */
      sinfo_struct.slot_init_fcn[sizeof(sinfo_struct.slot_init_fcn) - 1] =(char) NULL;

      {
        /* stripping off trailing new line character, '\n' from init function name if necessary */
        unsigned int i;
        for(i = 0; i < sizeof(sinfo_struct.slot_init_fcn); i++){
          if(sinfo_struct.slot_init_fcn[i] == '\n')
            sinfo_struct.slot_init_fcn[i] = (char)NULL;
        }
      }

    }
      element_num++;
      break;

    default:
      //  SAB...   since this is a daemon we reallly don't want to
      //  be doing printf's ....   
      fprintf(stderr, "\nIncorrect field present.\n");
    }


    }

    /* 
     *copying the contents of sinfo_struct into the array of similar structures if it's a valid entry 
     *(i.e. init fcn & dll filename are non-NULL...and the latter exists and is valid?)
     */
    if( (sinfo_struct.dll_location != NULL) &&
	(sinfo_struct.slot_init_fcn != NULL) ) {

      bcopy(&sinfo_struct,&sinfo[Index],sizeof(sinfo_struct));  // similar to sinfo[Index] = &sinfo_struct;
      PrintSlotInfo( &(sinfo[Index]) );
      Index++;

    }

#ifdef ALLOCATE
    if (slot_entry) {
      free(slot_entry);
      slot_entry = NULL;
    }
#endif

  }

  if( Index >= NUMBER_SLOTS_MANAGED )
    fprintf(stderr, "\nThe maximum number of slots supported has been reached\n");

  if (fp)
	  fclose( fp );


  NumberSlotsInDB = Index;	// This is required since it sets the count in
  				// the shared memory segment

  return TRUE;

}















